
#define MENU_size 9 
 const char* MENU_Strings[]  =
{
"1# PROFILE",
"2# FILTER SEL",
"3# SERVICE DATA",
"4# RESONANCE",
"5# FERRIT SET",
"6# PHASE_ADJ",
"7# VDI NOTCH",
"8# t-SOUND",
"9# GAIN",
"10# TX CURRENT"
};


//-----------------------------------------------buttons_scan----------------------------------------------------------
void buttons_scan()
{
 Key_status();
 if(button_n>0&&Button_FLAG==false)
 {
  pinMode(Out_Sound, INPUT);//Звук выкл
  if(button_n==1){adj_phase(); Ground_balance();}//
  if(button_n==2){Button_enter();Mem.Threshold--; if(Mem.Threshold < 1)Mem.Threshold=1;}
  if(button_n==3){Sound_s();Filter_select();}//
  if(button_n==4){Button_enter();Mem.Threshold++;}
  if(button_n==5){backlight_LCD();Menu();}
  power_check();
  EEPROM.put(1, Mem);//Сохранение  настроек
  LCD_start();
 }

}
//------------------------------------------------LED_LCD_ON_OFF---------------------------------------------------------------------------
void backlight_LCD()
{
  byte L_tick=0;
  while (button_n==5)
  {
   delay_M(100);
   L_tick++;
   Key_status();
   if (L_tick==15)
    {
     Mem.backlight=!Mem.backlight;
     digitalWrite(LED_LCD,Mem.backlight); 
     lcd.clear();
     if(digitalRead(LED_LCD))lcd.print(F("ON"));
     else lcd.print(F("OFF"));
     Button_enter();
     B_hold=true;
     delay_M(1000); 
     break;
    } 
  } 
}

 //------------------------------------------------------adj_phase()--------------------------------------------------------------------------------
void adj_phase()
{
  byte Tic=0;
  while (button_n==1)
  {
   delay_M(100);
   Tic++;
   Key_status();
   if (Tic==15)
    {
     Button_enter();
     Phase_adjustment();
     B_hold=true;
     break;
    } 
  } 
}
//------------------------------------------------------------------------------------------------------------------------------------
void Sound_s()
{
  byte Tic=0;
  while (button_n==3)
  {
   delay_M(100);
   Tic++;
   Key_status();
   if (Tic==15)
    {
     Button_enter();
     Sound_schemes();
     B_hold=true;
     break;
    } 
  } 
}
//----------------------------------------------------Button_hold--------------------------------------------------------------------
void Button_hold()
{
  static unsigned int B_tick;
  if(button_n) {B_tick++;}
  else  B_tick=0;
  if( B_tick>=10){Button_FLAG=false;}// Если кнопка зажата
  if( B_tick==10)BEEP();
  delay_M(100); 
}
//-------------------------------------------------Button_enter()--------------------------------------------------------------------
void Button_enter()
{
 BEEP();
 Button_FLAG=true;
 button_n=0;
 delay_M(100);
}
//----------------------------------------------------Button_if()----------------------------------------------------------------------
bool Button_if (byte button_in)
{
  if(button_n==button_in&&Button_FLAG==false) return true;
  else return false;
}
//-------------------------------------------------------Key_status()----------------------------------------------------
void Key_status()
{ 
 static const byte button_mask = B10111100;
 static const byte button_pin [] ={ 7,5,4,3,2 };
 power_check();
 button_n=0;
 DDRD  &=~ button_mask;// устанавливает выводы 2,3,4,5,7 как входные
 PORTD |=  button_mask;// режим PULLUP для выводов 2,3,4,5,7
 for(byte i=0; i<5; i++)if(digitalReadFast(button_pin[i])==false)button_n=i+1;//Опрос button пинов 
 DDRD  |=  button_mask;//// устанавливает выводы 2,3,4,5,7 как выходные
 if( button_n==0)Button_FLAG=false;
}

//-------------------------------------------------Menu()-----------------------------------------------------------------------------
void Menu()
{
static int MENU_index=0;
if(B_hold){B_hold=false; return;}
Button_enter();
lcd.clear();  
Menu_flag=true;
while (true)
 {   
  Key_status(); 
  if(Button_if(2)) {Button_enter(); MENU_index--;lcd.clear();}
  if(Button_if(3)) 
    {
      Button_enter();
      if (MENU_index==0)Profile_select();
      if (MENU_index==1)Filter_select();
      if (MENU_index==2)Service_data();
      if (MENU_index==3)F_scan();
      if (MENU_index==4)Ferit_seting();
      if (MENU_index==5)Phase_adjustment();
      if (MENU_index==6)VDI_notch(); 
      if (MENU_index==7)Sound_setting(); 
      if (MENU_index==8)Gain_ADC1115();
      if (MENU_index==9)TX_current();
      break;
    } 
  if(Button_if(4)) {Button_enter(); MENU_index++;lcd.clear();}
  if(Button_if(5)) {Button_enter(); break;}
  if(MENU_index<0)MENU_index=MENU_size;
  if(MENU_index>MENU_size)MENU_index=0; 
  lcd.setCursor(0,0);
  lcd.print('>');lcd.print(MENU_Strings[MENU_index]);
  lcd.setCursor(0,1);lcd.print(' '); 
  if(MENU_index==0)lcd.print(MENU_Strings[MENU_size]); 
  else lcd.print(MENU_Strings[MENU_index-1]); 
  delay_M(100); 
 }
Menu_flag=false;
lcd.clear();
}


